// copyright 2022 zamfofex
// license: AGPLv3 or later

#include <mimimi/allocators.h>
#include <mimimi/malloc.h>

#include <stdlib.h>

static void *mimimi_malloc_allocate(unsigned int size)
{
	void *data = malloc(size);
	if (data == NULL) exit(1);
	return data;
}

static void *mimimi_malloc_reallocate(void *data, unsigned int size)
{
	data = realloc(data, size);
	if (data == NULL) exit(1);
	return data;
}

static struct mimimi_allocator mimimi_malloc_value = {&mimimi_malloc_allocate, &mimimi_malloc_reallocate, &free, NULL};

struct mimimi_allocator *mimimi_malloc = &mimimi_malloc_value;
